local LBPCheckFrame = LBP:CreateFrame("frame", "test", UIPARENT, nil, "TOPLEFT", UIPARENT, "TOPLEFT", 0, 0, 1, 1)
-- LBPCheckFrame.text = LBP:CreateFontString(LBPCheckFrame, "textbox","ARTWORK", "GameFontNormal", "TOPLEFT", LBPCheckFrame, "TOPLEFT", 600, 0, 200, 700, "LEFT", "TOP", 1, 1, 1, 1)
-- LBPCheckFrame.text:SetText(" ")
-- LBPCheckFrame.text:Show()

-- function LBPdebug(msg)
	-- LBPCheckFrame.text:SetText(LBPCheckFrame.text:GetText() .."\n"..msg)
	-- LBPCheckFrame.text:SetText(msg)
-- end



LBPCheckFrame:Show()

local index, x, y, instanceID, name, description, encounterID, rootSectionID, link, TLx,TLy,BRx,BRy, cx, cy, unitX, unitY, abstand, instance, merken, isInstance, instanceType
local encounter_db = {}




function LBP.GetMapEncounter()
	-- local id = GetCurrentMapAreaID()
	-- local level = GetCurrentMapDungeonLevel()
	SetMapToCurrentZone()
	
	encounter_db = {}
	index = 1
	
	while EJ_GetMapEncounter(index) do		
		x, y, instanceID, _, _, encounterID = EJ_GetMapEncounter(index)
		
		encounter_db[encounterID] = {
			["x"] = x, 
			["y"] = 1-y
		}
		
		index = index + 1
	end	
	LBP.GetMapDimension()
	
	-- SetMapByID(id)
	-- SetDungeonMapLevel(level)
end

function LBP.GetMapDimension()
	-- local id = GetCurrentMapAreaID()
	-- local level = GetCurrentMapDungeonLevel()
	SetMapToCurrentZone()
	isInstance, instanceType = IsInInstance()
	
	_,TLx,TLy,BRx,BRy = GetCurrentMapZone()
	if isInstance then
		_,TLx,TLy,BRx,BRy = GetCurrentMapDungeonLevel()
	end
	if not TLx then
		_,TLx,TLy,BRx,BRy = GetCurrentMapZone()
	end
	
	if TLx then
		cx = abs(TLx-BRx) -- width of zone in yards
		cy = abs(TLy-BRy) -- height of zone in yards	
		
		else
		cx = 1.23
		cy = 0
	end
	
	-- SetMapByID(id)
	-- SetDungeonMapLevel(level)
	
	return cx, cy
end





function LBP.EncounterCheck( self )
	
	if not LBPMainFrame then
		return
	end
	
	if cx == 1.23 then
		LBP.GetMapDimension()
		return
	end
	
	if InCombatLockdown() or WorldMapDetailFrame:IsVisible() or not (instanceType=="raid") or UnitIsDead("player") or cx == 0 then
	-- if InCombatLockdown() or WorldMapDetailFrame:IsVisible() or UnitIsDead("player") or cx == 0 then
		if LBPMainFrame then
			LBPMainFrame:Hide()
		end
		return	
	end
	
	
	-- index = 1
	
	unitX, unitY = GetPlayerMapPosition("player");
	
	abstand = 10000
	
	for index in pairs(encounter_db) do
		if math.sqrt(((encounter_db[index]["x"]-unitX)*cx)^2 +((encounter_db[index]["y"]-unitY)*cy)^2) < abstand then
			encounterID = index
			abstand = math.sqrt(((encounter_db[index]["x"]-unitX)*cx)^2 +((encounter_db[index]["y"]-unitY)*cy)^2)
			
		end
	end
	
	
	
	
	-- if not EJ_GetMapEncounter(1) then
		-- x = 0.5
		-- y = 0.5
		-- encounterID = 1392
		-- instanceID = 669
		
		-- abstand = math.sqrt(((x-unitX)*cx)^2 +((y-unitY)*cy)^2)
	-- end
	-- print(abstand)
	-- LBPdebug(abstand)
	
	
	if abstand < 70 then
		if encounterID ~= LBPMainFrame.encounterID then
			LBPMainFrame.encounterID = encounterID
			LBPMainFrame.instanceID = instanceID
			
			LBPMainFrame:SetAlpha(1)
			LBPMainFrame:Check()
		end	
		
		else
		LBPMainFrame.encounterID = nil
		LBPMainFrame.instanceID = nil
		LBPMainFrame:Hide()
		LBPMainFrame:SetAlpha(1)
	end
	
end


LBPCheckFrame:SetScript("OnUpdate", function(self) LBP:EncounterCheck() end)




LBPCheckFrame:SetScript("OnEvent", 
	function(self, event, ... ) 
	
		if event == "PLAYER_TALENT_UPDATE" or event == "GLYPH_UPDATED" or event == "PLAYER_EQUIPMENT_CHANGED" then
			if LBPMainFrame then
				LBPMainFrame.encounterID = nil
				LBPMainFrame.instanceID = nil
			end
		end
	
		-- if the worldmap is open, wait till it's closed
		if WorldMapDetailFrame:IsVisible() then
			LBPCheckFrame:SetScript("OnUpdate", function (self)
				if not WorldMapDetailFrame:IsVisible() then
					LBP.GetMapEncounter()
					LBPCheckFrame:SetScript("OnUpdate", nil)
				end
			end)
			
			else
			LBP.GetMapEncounter()
		end
		
		if LBPMainFrame then
			-- LBPMainFrame.encounterID = nil
			-- LBPMainFrame.instanceID = nil
		end
	end
)

LBPCheckFrame:RegisterEvent("PLAYER_TALENT_UPDATE")
LBPCheckFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
--LBPCheckFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
LBPCheckFrame:RegisterEvent("ZONE_CHANGED");
LBPCheckFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
LBPCheckFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
LBPCheckFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
LBPCheckFrame:RegisterEvent("GLYPH_UPDATED");








